package main

import (
	"context"
	"log"
	"strings"
	"time"

	"github.com/go-telegram/bot"
	"github.com/go-telegram/bot/models"
)

func defaultHandler(ctx context.Context, b *bot.Bot, update *models.Update) {
	// b.SendMessage(ctx, &bot.SendMessageParams{
	// 	ChatID: update.Message.Chat.ID,
	// 	Text:   "hello!",
	// })
	log.Println(*update)
}

func registerChat(ctx context.Context, b *bot.Bot, update *models.Update) {
	msg := update.Message
	log.Println("registering", msg.Chat.ID)
	m, err := FetchMemberFromChat(ctx, b, msg.Chat.ID, msg.From.ID)
	if err == nil {
		if !IsAdmin(*m) {
			log.Println("register: user is not admin")
			return
		}
		args := strings.Split(msg.Text, " ")
		if len(args) == 1 {
			log.Println("register: there's no code")
			return
		}
		if !UseActivation(args[1]) {
			log.Println("register: wrong code")
			return
		}
		if err := ActivateChat(msg.Chat.ID); err != nil {
			log.Println("Error activating chat: ", err)
			return
		}
		b.DeleteMessage(ctx, &bot.DeleteMessageParams{ChatID: msg.Chat.ID, MessageID: msg.ID})
		sent, err := b.SendMessage(ctx, &bot.SendMessageParams{ChatID: msg.Chat.ID, Text: "Чат зарегистрирован", MessageThreadID: msg.MessageThreadID})
		if err == nil {
			err := AddMessageToDelete(MessageToDelete{MessageId: sent.ID, ChatId: msg.Chat.ID, DeleteDate: time.Now().Add(1 * time.Minute).Unix()})
			if err != nil {
				log.Println("register: failed to add to delete", err)
			}
		}
	} else {
		log.Println("register: error", err)
	}
}

func handleNewJoined(ctx context.Context, b *bot.Bot, u *models.Update) {
	for _, user := range u.Message.NewChatMembers {
		log.Println(user)
	}
}

func banUser(ctx context.Context, b *bot.Bot, u *models.Update) {

}
